---
title: 'SyntaxError: function statement requires a name'
slug: Web/JavaScript/Reference/Errors/Unnamed_function_statement
tags:
  - Error
  - Errors
  - JavaScript
  - SyntaxError
---
<div>{{jsSidebar("Errors")}}</div>

<p>The JavaScript exception "function statement requires a name" occurs when there is a <a href="/en-US/docs/Web/JavaScript/Reference/Statements/function">function statement</a> in the code that requires a name.</p>

<h2 id="Message">Message</h2>

<pre class="syntaxbox">Syntax Error: Expected identifier (Edge)
SyntaxError: function statement requires a name [Firefox]
SyntaxError: Unexpected token ( [Chrome]
</pre>

<h2 id="Error_type">Error type</h2>

<p>{{jsxref("SyntaxError")}}</p>

<h2 id="What_went_wrong">What went wrong?</h2>

<p>There is a <a href="/en-US/docs/Web/JavaScript/Reference/Statements/function">function statement</a> in the code that requires a name. You'll need to check how functions are defined and if you need to provide a name for it, or if the function in question needs to be a function expression, an <a href="/en-US/docs/Glossary/IIFE">IIFE</a>, or if the function code is placed correctly in this context at all.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Statements_vs_expressions">Statements vs expressions</h3>

<p>A <em><a href="/en-US/docs/Web/JavaScript/Reference/Statements/function">function statement</a></em> (or <em>function declaration</em>) requires a name, this won't work:</p>

<pre class="brush: js example-bad">function () {
  return 'Hello world';
}
// SyntaxError: function statement requires a name
</pre>

<p>You can use a <a href="/en-US/docs/Web/JavaScript/Reference/Operators/function">function expression</a> (assignment) instead:</p>

<pre class="brush: js example-good">var greet = function() {
  return 'Hello world';
};</pre>

<p>Or, you function is maybe intended to be an <a href="https://en.wikipedia.org/wiki/Immediately-invoked_function_expression">IIFE</a> (Immediately Invoked Function Expression), which is a function that runs as soon as it is defined. You will need a few more braces in this case:</p>

<pre class="brush: js example-good">(function () {

})();</pre>

<h3 id="Labeled_functions">Labeled functions</h3>

<p>If you are using function <a href="/en-US/docs/Web/JavaScript/Reference/Statements/label">labels</a>, you will still need to provide a function name after the <code>function</code> keyword. This doesn't work:</p>

<pre class="brush: js example-bad">function Greeter() {
  german: function () {
    return "Moin";
  }
}
// SyntaxError: function statement requires a name
</pre>

<p>This would work, for example:</p>

<pre class="brush: js example-good">function Greeter() {
  german: function g() {
    return "Moin";
  }
}</pre>

<h3 id="Object_methods">Object methods</h3>

<p>If you intended to create a method of an object, you will need to create an object. The following syntax without a name after the <code>function</code> keyword is valid then.</p>

<pre class="brush: js example-good">var greeter = {
  german: function () {
    return "Moin";
  }
};</pre>

<h3 id="Callback_syntax">Callback syntax</h3>

<p>Also, check your syntax when using callbacks. Brackets and commas can get difficult easily.</p>

<pre class="brush: js example-bad">promise.then(
  function() {
    console.log("success");
  });
  function() {
    console.log("error");
}
// SyntaxError: function statement requires a name
</pre>

<p>Correct would be:</p>

<pre class="brush: json example-good">promise.then(
  function() {
    console.log("success");
  },
  function() {
    console.log("error");
  }
);
</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Functions">Functions in the JavaScript Guide</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Statements/function">function statement</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Operators/function">function expression</a></li>
 <li><a href="https://en.wikipedia.org/wiki/Immediately-invoked_function_expression">IIFE</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Statements/label">label</a></li>
</ul>
